;;;
;;; lazy.h
;;;
;;; created: <Sat Jul  8 17:27:12 2000>
;;; last modified: <Sun Jul  9 13:29:18 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;
;;; For some guys who have problems with capital letters :)
;;;


%ifndef _lazy_h_
%define _lazy_h_

;;; io.h
%ifdef _io_h_
%idefine writestring WriteString
%idefine writestr WriteStr
%idefine writeerr WriteErr
%idefine writechar WriteChar
%idefine writechr WriteChr
%idefine getchar GetChar
%idefine getchr GetChr
%idefine getstring GetString
%idefine getstr GetStr
%idefine writef Writef
%idefine writefany WritefANY
%idefine writefstdout WritefSTDOUT
%idefine writefstderr WritefSTDERR
%idefine writedebuginfo WriteDebugInfo
%idefine writeint WriteInt
%idefine writehex WriteHex
%idefine writefloat WriteFloat
%idefine writefloatsc10 WriteFloatScE
%idefine writefloatsce WriteFloatSce
%idefine waitkeypressed WaitKeypressed
%endif	; _io_h_

;;; misc.h
%ifdef _misc_h_
%idefine startpoint StartPoint
%idefine getcputype GetCPUType
%idefine assert Assert
%idefine random Random
%idefine randomstring RandomString
%endif	; _misc_h_

;;; string.h
%ifdef _string_h_
%idefine geterrorstr GetErrorStr
%idefine crc32init Crc32Init
%idefine crc32byte Crc32Byte
%idefine crc32 Crc32
%idefine strncpy Strncpy
%idefine strcpy Strcpy
%idefine strlen Strlen
%endif	; _string_h_

;;; zip.h
%ifdef _zip_h_
%idefine zipgzip ZipGZIP
%idefine unzipgzip UnzipGZIP
%idefine zipbzip2 ZipBZIP2
%idefine unzipbzip2 UnzipBZIP2
%idefine ziplzw ZipLZW
%idefine unziplzw UnzipLZW
%endif	; _zip_h_

;;; ipc.h
%ifdef _ipc_h_
%idefine pipein PipeIN
%idefine pipeine PipeIn
%idefine pipeout PipeOUT
%idefine pipeoute PipeOut
%idefine pipeio PipeIO
%idefine pipeioe PipeIo
%endif	; _ipc_h_

;;; seq.h
%ifdef _seq_h_
%idefine seq_opene SEQ_open
%idefine seq_open SEQ_Open
%idefine seq_close SEQ_close
%idefine seq_bufdump SEQ_bufdump
%idefine seq_sendevent SEQ_sendevent
%idefine seq_writepatch SEQ_writepatch
%idefine seq_resetsamples SEQ_resetsamples
%idefine seq_start_note SEQ_start_note
%idefine seq_stop_note SEQ_stop_note
%idefine seq_pgm_change SEQ_pgm_change
%idefine seq_set_patch SEQ_set_patch
%endif	; _seq_h_

;;; sys.h
%ifdef _sys_h_
%idefine execsp ExecSP
%idefine execspe ExecSp
%idefine socket Socket
%idefine binnd Bind
%idefine connect Connect
%idefine recv Recv
%idefine send Send
%idefine sleep Sleep
%endif	; _sys_h_

;;; gus.h
%ifdef _gus_h_
%idefine gus_numvoices GUS_numvoices
%idefine gus_voiceon GUS_voiceon
%idefine gus_voiceoff GUS_voiceoff
%idefine gus_voicefade GUS_voicefade
%idefine gus_voicemode GUS_voicemode
%idefine gus_voicebala GUS_voicebala
%idefine gus_voicefrew GUS_voicefreq
%idefine gus_voicevol GUS_voicevol
%idefine gus_voicevol2 GUS_voicevol2
%idefine gus_ramprange GUS_ramprange
%idefine gus_ramprate GUS_ramprate
%idefine gus_rampmode GUS_rampmode
%idefine gus_rampon GUS_rampon
%idefine gus_rampoff GUS_rampoff
%idefine gus_volume_scale GUS_volume_scale
%idefine gus_voice_pos GUS_voice_pos
%endif	; _gus_h_

;;; mem.h
%ifdef _mem_h_
%idefine memoryinit MemoryInit
%idefine memoryallocate MemoryAllocate
%idefine memoryresize MemoryResize
%idefine memoryfree MemoryFree
%idefine memorytune MemoryTune
%idefine memoryprotect MemoryProtect
%idefine memorygetsize MemoryGetsize
%idefine memoryprintchunkstruc MemoryPrintChunkStruc
%idefine memorysetproc MemorySetProc
%idefine memorysetpid MemorySetPid
%endif	; _mem_h_


%endif	; _lazy_h_

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End:
