;;;
;;; x_def.h
;;;
;;; created: <Wed Mar  8 21:35:02 2000>
;;; last modified: <Sat Mar 30 12:53:17 2002>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;
;;; This defines the symbols needed by libASM (and propably your program?)
;;; for calling the x functions.
;;;

%ifndef _x_def_h_
%define _x_def_h_

%define X_PROTOCOL 11		; current protocol version
%define X_PROTOCOL_REVISION 0	; current minor version

%define xTrue 1
%define xFalse 0
%define None 0
%define CopyFromParent 0
%define InputOutput 1
%define InputOnly 2
%define PointerWindow 0
%define InputFocus 1
%define PointerRoot 1
%define AnyPropertyType 0
%define AnyKey 0
%define AnyButton 0
%define AllTemporary 0
%define CurrentTime 0
%define NoSymbol 0
%define AllPlanes (~0)

%define XYBitmap 0		; depth 1, XYFormat
%define XYPixmap 1		; depth == drawable depth
%define ZPixmap 2		; depth == drawable depth

;;;*
;;;* Window attributes for CreateWindow and ChangeWindowAttributes:
;;;*  CWBackPixmap, CWBackPixel, CWBorderPixmap, CWBorderPixel, CWBitGravity,
;;;*  CWWinGravity, CWBackingStore, CWBackingPlanes, CWBackingPixel,
;;;*  CWOverrideRedirect, CWSaveUnder, CWEventMask, CWDontPropagate,
;;;*  CWColormap, CWCursor, AllMaskBits
;;;* To set some of these attributes or' the wanted together (and pass them
;;;* in the 'valuemask' parameter) and set their values in the
;;;* 'XSetWindowAttributes' structure (passed via 'attributes')
;;;*
%define CWBackPixmap (1<<0)
%define CWBackPixel (1<<1)
%define CWBorderPixmap (1<<2)
%define CWBorderPixel (1<<3)
%define CWBitGravity (1<<4)
%define CWWinGravity (1<<5)
%define CWBackingStore (1<<6)
%define CWBackingPlanes (1<<7)
%define CWBackingPixel (1<<8)
%define CWOverrideRedirect (1<<9)
%define CWSaveUnder (1<<10)
%define CWEventMask (1<<11)
%define CWDontPropagate (1<<12)
%define CWColormap (1<<13)
%define CWCursor (1<<14)
%define AllMaskBits (CWBackPixmap|CWBackPixel|CWBorderPixmap|CWBorderPixel|CWBitGravity|CWWinGravity|CWBackingStore|CWBackingPlanes|CWBackingPixel|CWOverrideRedirect|CWSaveUnder|CWEventMask|CWDontPropagate|CWColormap|CWCursor)

%define LSBFirst 0
%define MSBFirst 1

;;; Reply codes
%define X_Reply	1	; Normal reply
%define X_Error	0	; Error

%ifdef ___libASM___
;;; Request codes
%define X_CreateWindow 1
%define X_ChangeWindowAttributes 2
%define X_GetWindowAttributes 3
%define X_DestroyWindow 4
%define X_DestroySubwindows 5
%define X_ChangeSaveSet 6
%define X_ReparentWindow 7
%define X_MapWindow 8
%define X_MapSubwindows 9
%define X_UnmapWindow 10
%define X_UnmapSubwindows 11
%define X_ConfigureWindow 12
%define X_CirculateWindow 13
%define X_GetGeometry 14
%define X_QueryTree 15
%define X_InternAtom 16
%define X_GetAtomName 17
%define X_ChangeProperty 18
%define X_DeleteProperty 19
%define X_GetProperty 20
%define X_ListProperties 21
%define X_SetSelectionOwner 22
%define X_GetSelectionOwner 23
%define X_ConvertSelection 24
%define X_SendEvent 25
%define X_GrabPointer 26
%define X_UngrabPointer 27
%define X_GrabButton 28
%define X_UngrabButton 29
%define X_ChangeActivePointerGrab 30
%define X_GrabKeyboard 31
%define X_UngrabKeyboard 32
%define X_GrabKey 33
%define X_UngrabKey 34
%define X_AllowEvents 35
%define X_GrabServer 36
%define X_UngrabServer 37
%define X_QueryPointer 38
%define X_GetMotionEvents 39
%define X_TranslateCoords 40
%define X_WarpPointer 41
%define X_SetInputFocus 42
%define X_GetInputFocus 43
%define X_QueryKeymap 44
%define X_OpenFont 45
%define X_CloseFont 46
%define X_QueryFont 47
%define X_QueryTextExtents 48
%define X_ListFonts 49
%define X_ListFontsWithInfo 	 50
%define X_SetFontPath 51
%define X_GetFontPath 52
%define X_CreatePixmap 53
%define X_FreePixmap 54
%define X_CreateGC 55
%define X_ChangeGC 56
%define X_CopyGC 57
%define X_SetDashes 58
%define X_SetClipRectangles 59
%define X_FreeGC 60
%define X_ClearArea 61
%define X_CopyArea 62
%define X_CopyPlane 63
%define X_PolyPoint 64
%define X_PolyLine 65
%define X_PolySegment 66
%define X_PolyRectangle 67
%define X_PolyArc 68
%define X_FillPoly 69
%define X_PolyFillRectangle 70
%define X_PolyFillArc 71
%define X_PutImage 72
%define X_GetImage 73
%define X_PolyText8 74
%define X_PolyText16 75
%define X_ImageText8 76
%define X_ImageText16 77
%define X_CreateColormap 78
%define X_FreeColormap 79
%define X_CopyColormapAndFree 80
%define X_InstallColormap 81
%define X_UninstallColormap 82
%define X_ListInstalledColormaps 83
%define X_AllocColor 84
%define X_AllocNamedColor 85
%define X_AllocColorCells 86
%define X_AllocColorPlanes 87
%define X_FreeColors 88
%define X_StoreColors 89
%define X_StoreNamedColor 90
%define X_QueryColors 91
%define X_LookupColor 92
%define X_CreateCursor 93
%define X_CreateGlyphCursor 94
%define X_FreeCursor 95
%define X_RecolorCursor 96
%define X_QueryBestSize 97
%define X_QueryExtension 98
%define X_ListExtensions 99
%define X_ChangeKeyboardMapping 100
%define X_GetKeyboardMapping 101
%define X_ChangeKeyboardControl 102
%define X_GetKeyboardControl 103
%define X_Bell 104
%define X_ChangePointerControl 105
%define X_GetPointerControl 106
%define X_SetScreenSaver 107
%define X_GetScreenSaver 108
%define X_ChangeHosts 109
%define X_ListHosts 110
%define X_SetAccessControl 111
%define X_SetCloseDownMode 112
%define X_KillClient 113
%define X_RotateProperties 114
%define X_ForceScreenSaver 115
%define X_SetPointerMapping 116
%define X_GetPointerMapping 117
%define X_SetModifierMapping 118
%define X_GetModifierMapping 119
%define X_NoOperation 127
%endif ; ___libASM___


;;; Property modes
%define PropModeReplace 0
%define PropModePrepend 1
%define PropModeAppend 2

%define XA_ATOM 4
%define XA_STRING 31
%define XA_WM_CLIENT_MACHINE 36
%define XA_WM_ICON_NAME 37
%define XA_WM_NAME 39

;;;
;;; graphics functions, as in GC.alu
;;;
%define	GXclear			0x0	; 0
%define GXand			0x1	; src AND dst
%define GXandReverse		0x2	; src AND NOT dst
%define GXcopy			0x3	; src
%define GXandInverted		0x4	; NOT src AND dst
%define	GXnoop			0x5	; dst
%define GXxor			0x6	; src XOR dst
%define GXor			0x7	; src OR dst
%define GXnor			0x8	; NOT src AND NOT dst
%define GXequiv			0x9	; NOT src XOR dst
%define GXinvert		0xa	; NOT dst
%define GXorReverse		0xb	; src OR NOT dst
%define GXcopyInverted		0xc	; NOT src
%define GXorInverted		0xd	; NOT src OR dst
%define GXnand			0xe	; NOT src OR NOT dst
%define GXset			0xf	; 1

;;; LineStyle
%define LineSolid		0
%define LineOnOffDash		1
%define LineDoubleDash		2

;;; capStyle
%define CapNotLast		0
%define CapButt			1
%define CapRound		2
%define CapProjecting		3

;;; joinStyle
%define JoinMiter		0
%define JoinRound		1
%define JoinBevel		2

;;; fillStyle
%define FillSolid		0
%define FillTiled		1
%define FillStippled		2
%define FillOpaqueStippled	3

;;; fillRule
%define EvenOddRule		0
%define WindingRule		1

;;; subwindow mode
%define ClipByChildren		0
%define IncludeInferiors	1

;;; SetClipRectangles ordering
%define Unsorted		0
%define YSorted			1
%define YXSorted		2
%define YXBanded		3

;;; CoordinateMode for drawing routines
%define CoordModeOrigin		0	; relative to the origin
%define CoordModePrevious       1	; relative to previous point

;;; Polygon shapes
%define Complex			0	; paths may intersect
%define Nonconvex		1	; no paths intersect, but not convex
%define Convex			2	; wholly convex

;;; Arc modes for PolyFillArc
%define ArcChord		0	; join endpoints of arc
%define ArcPieSlice		1	; join endpoints to center of arc

;;;
;;; GC components: masks used in CreateGC, CopyGC, ChangeGC, OR'ed into
;;; GC.stateChanges
;;;
%define GCFunction		(1<<0)
%define GCPlaneMask		(1<<1)
%define GCForeground		(1<<2)
%define GCBackground		(1<<3)
%define GCLineWidth		(1<<4)
%define GCLineStyle		(1<<5)
%define GCCapStyle		(1<<6)
%define GCJoinStyle		(1<<7)
%define GCFillStyle		(1<<8)
%define GCFillRule		(1<<9) 
%define GCTile			(1<<10)
%define GCStipple		(1<<11)
%define GCTileStipXOrigin	(1<<12)
%define GCTileStipYOrigin	(1<<13)
%define GCFont 			(1<<14)
%define GCSubwindowMode		(1<<15)
%define GCGraphicsExposures	(1<<16)
%define GCClipXOrigin		(1<<17)
%define GCClipYOrigin		(1<<18)
%define GCClipMask		(1<<19)
%define GCDashOffset		(1<<20)
%define GCDashList		(1<<21)
%define GCArcMode		(1<<22)

%define GCLastBit		22


;;;
;;; XC-MISC Extension for ID-allocation
;;;
%define X_XCMiscGetVersion	0
%define X_XCMiscGetXIDRange	1
%define X_XCMiscGetXIDList	2
%define XCMiscNumberEvents	0
%define XCMiscNumberErrors	0
%define XCMiscMajorVersion	1
%define XCMiscMinorVersion	1


;;;
;;; MIT-SHM Extension
;;;
%define X_ShmQueryVersion	0
%define X_ShmAttach		1
%define X_ShmDetach		2
%define X_ShmPutImage		3
%define X_ShmGetImage		4
%define X_ShmCreatePixmap	5
%define ShmCompletion		0
%define ShmNumberEvents		(ShmCompletion + 1)
%define BadShmSeg		0
%define ShmNumberErrors		(BadShmSeg + 1)
%define SHM_MAJOR_VERSION	1 ; current version numbers
%define SHM_MINOR_VERSION	1

;;; ConfigureWindow structure
%define CWX			(1<<0)
%define CWY			(1<<1)
%define CWWidth			(1<<2)
%define CWHeight		(1<<3)
%define CWBorderWidth		(1<<4)
%define CWSibling		(1<<5)
%define CWStackMode		(1<<6)

;;; Bit Gravity
%define ForgetGravity		0
%define NorthWestGravity	1
%define NorthGravity		2
%define NorthEastGravity	3
%define WestGravity		4
%define CenterGravity		5
%define EastGravity		6
%define SouthWestGravity	7
%define SouthGravity		8
%define SouthEastGravity	9
%define StaticGravity		10

;;; Window gravity + bit gravity above
%define UnmapGravity		0

;;; Used in CreateWindow for backing-store hint
%define NotUseful               0
%define WhenMapped              1
%define Always                  2

;;; Used in GetWindowAttributes reply
%define IsUnmapped		0
%define IsUnviewable		1
%define IsViewable		2

;;; Used in ChangeSaveSet
%define SetModeInsert           0
%define SetModeDelete           1

;;; Used in ChangeCloseDownMode
%define DestroyAll              0
%define RetainPermanent         1
%define RetainTemporary         2

;;; Window stacking method (in configureWindow)
%define Above                   0
%define Below                   1
%define TopIf                   2
%define BottomIf                3
%define Opposite                4

;;; Circulation direction
%define RaiseLowest             0
%define LowerHighest            1



%endif	; _x_def_h_



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: