;;;
;;; x_struc_x.h
;;;
;;; created: <Wed Mar  8 21:33:40 2000>
;;; last modified: <Thu Jul 13 21:45:57 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%ifndef _x_struc_x_h_
%define _x_struc_x_h_

;;; Structures used by the Xserver
struc xConnClientPrefix
.byteOrder:		resb 1
			resb 1
.majorVersion:		resw 1
.minorVersion:		resw 1
.nbytesAuthProto:	resw 1
.nbytesAuthString:	resw 1
			resw 1
endstruc


struc xConnSetupPrefix
.success:		resb 1
.lengthReason:		resb 1	; num bytes in string following if failure
.majorVersion:		resw 1
.minorVersion:		resw 1
.length:		resw 1	; 1/4 additional bytes in setup info
endstruc


struc xConnSetup
.release:		resd 1
.ridBase:		resd 1
.ridMask:		resd 1
.motionBufferSize:	resd 1
.nbytesVendor:		resw 1	; number of bytes in vendor string
.maxRequestSize:	resw 1
.numRoots:		resb 1	; number of roots structs to follow
.numFormats:		resb 1	; number of pixmap formats
.imageByteOrder:	resb 1	; LSBFirst, MSBFirst
.bitmapBitOrder:	resb 1	; LeastSignificant, MostSign...
.bitmapScanlineUnit:	resb 1	; 8, 16, 32
.bitmapScanlinePad:	resb 1	; 8, 16, 32
.minKeyCode:		resb 1
.maxKeyCode:		resb 1
			resd 1
endstruc


struc xPixmapFormat
.depth:			resb 1
.bitsPerPixel:		resb 1
.scanLinePad:		resb 1
			resb 1
			resd 1
endstruc


struc xDepth
.depth:			resb 1
			resb 1
.nVisuals:		resw 1	; number of xVisualType structures following
			resd 1
endstruc


struc xVisualType
.visualID:		resd 1 ; top 3 bits have to be zero
.class:			resb 1
.bitsPerRGB:		resb 1
.colormapEntries:	resw 1
.redMask:		resd 1
.greenMask:		resd 1
.blueMask:		resd 1
			resd 1
endstruc


struc xWindowRoot
.windowId:		resd 1	; top 3 bits have to be zero
.defaultColormap:	resd 1	; top 3 bits have to be zero
.whitePixel:		resd 1
.blackPixel:		resd 1
.currentInputMask:	resd 1
.pixWidth:		resw 1
.pixHeight:		resw 1
.mmWidth:		resw 1
.mmHeight:		resw 1
.minInstalledMaps:	resw 1
.maxInstalledMaps:	resw 1
.rootVisualID:		resd 1	; top 3 bits have to be zero
.backingStore:		resb 1
.saveUnders:		resb 1
.rootDepth:		resb 1
.nDepths:		resb 1	; number of xDepth structures following
endstruc


;;;*
;;;* XSetWindowAttributes
;;;*  .background_pixmap:	background or None or ParentRelative
;;;*  .background_pixel:	background pixel
;;;*  .border_pixmap:	border of the window
;;;*  .border_pixel:	border pixel value
;;;*  .bit_gravity:		one of bit gravity values
;;;*  .win_gravity:		one of the window gravity values
;;;*  .backing_store:	NotUseful, WhenMapped, Always
;;;*  .backing_planes:	planes to be preseved if possible
;;;*  .backing_pixel:	value to use in restoring planes
;;;*  .save_under:		should bits under be saved? (popups)
;;;*  .event_mask:		set of events that should be saved
;;;*  .do_not_propagate_mask:	set of events that should not propagate
;;;*  .override_redirect:	boolean value for override-redirect
;;;*  .colormap:		color map to be associated with window
;;;*  .cursor:		cursor to be displayed (or None)
;;;*
struc XSetWindowAttributes
.background_pixmap:	resd 1	; background or None or ParentRelative
.background_pixel:	resd 1	; background pixel
.border_pixmap:		resd 1	; border of the window
.border_pixel:		resd 1	; border pixel value
.bit_gravity:		resd 1	; one of bit gravity values
.win_gravity:		resd 1	; one of the window gravity values
.backing_store:		resd 1	; NotUseful, WhenMapped, Always
.backing_planes:	resd 1	; planes to be preseved if possible
.backing_pixel:		resd 1	; value to use in restoring planes
.save_under:		resd 1	; should bits under be saved? (popups)
.event_mask:		resd 1	; set of events that should be saved
.do_not_propagate_mask:	resd 1	; set of events that should not propagate
.override_redirect:	resd 1	; boolean value for override-redirect
.colormap:		resd 1	; color map to be associated with window
.cursor:		resd 1	; cursor to be displayed (or None)
endstruc


;;;*
;;;* Visual
;;;*  .ext_data:		hook for extension to hang data
;;;*  .visualid:		visual id of this visual
;;;*  .class:		class of screen (monochrome, etc.)
;;;*  .red_mask:		mask values
;;;*  .green_mask:
;;;*  .blue_mask:
;;;*  .bits_per_rgb:	log base 2 of distinct color values
;;;*  .map_entries:		color map entries
;;;*
;;;*  Visual structure; contains information about colormapping possible.
;;;*
struc Visual
.ext_data:		resd 1	; hook for extension to hang data
.visualid:		resd 1	; visual id of this visual
.class:			resd 1	; class of screen (monochrome, etc.)
.red_mask:		resd 1	; mask values
.green_mask:		resd 1
.blue_mask:		resd 1
.bits_per_rgb:		resd 1	; log base 2 of distinct color values
.map_entries:		resd 1	; color map entries
endstruc


;;;*
;;;* XGCValues
;;;*  .function:		logical operation
;;;*  .plane_mask:		plane mask
;;;*  .foreground:		foreground pixel
;;;*  .background:		background pixel
;;;*  .line_width:		line width
;;;*  .line_style:		LineSolid, LineOnOffDash, LineDoubleDash
;;;*  .cap_style:		CapNotLast, CapButt, CapRound, CapProjecting
;;;*  .join_style:		JoinMiter, JoinRound, JoinBevel
;;;*  .fill_style:		FillSolid, FillTiled, FillStippled, FillOpaeueStippled
;;;*  .fill_rule:		EvenOddRule, WindingRule
;;;*  .arc_mode:		ArcChord, ArcPieSlice
;;;*  .tile:		tile pixmap for tiling operations
;;;*  .stipple:		stipple 1 plane pixmap for stipping
;;;*  .ts_x_origin:		offset for tile or stipple operations
;;;*  .ts_y_origin:
;;;*  .font:		default text font for text operations
;;;*  .subwindow_mode:	ClipByChildren, IncludeInferiors
;;;*  .graphics_exposures:	boolean, should exposures be generated
;;;*  .clip_x_origin:	origin for clipping
;;;*  .clip_y_origin:
;;;*  .clip_mask:		bitmap clipping; other calls for rects
;;;*  .dash_offset:		patterned/dashed line information
;;;*  .dashes:
;;;*
;;;*
;;;*  Data structure for setting graphics context.
;;;*
struc XGCValues
.function:		resd 1	; logical operation
.plane_mask:		resd 1	; plane mask
.foreground:		resd 1	; foreground pixel
.background:		resd 1	; background pixel
.line_width:		resd 1	; line width
.line_style:		resd 1	; LineSolid, LineOnOffDash, LineDoubleDash
.cap_style:		resd 1	; CapNotLast, CapButt, CapRound, CapProjecting
.join_style:		resd 1	; JoinMiter, JoinRound, JoinBevel
.fill_style:		resd 1	; FillSolid, FillTiled, FillStippled, FillOpaeueStippled
.fill_rule:		resd 1	; EvenOddRule, WindingRule
.arc_mode:		resd 1	; ArcChord, ArcPieSlice
.tile:			resd 1	; tile pixmap for tiling operations
.stipple:		resd 1	; stipple 1 plane pixmap for stipping
.ts_x_origin:		resd 1	; offset for tile or stipple operations
.ts_y_origin:		resd 1
.font:			resd 1	; default text font for text operations
.subwindow_mode:	resd 1	; ClipByChildren, IncludeInferiors
.graphics_exposures:	resd 1	; boolean, should exposures be generated
.clip_x_origin:		resd 1	; origin for clipping
.clip_y_origin:		resd 1
.clip_mask:		resd 1	; bitmap clipping; other calls for rects
.dash_offset:		resd 1	; patterned/dashed line information
.dashes:		resd 1
endstruc


;;;*
;;;* XShmSegmentInfo
;;;*  .shmseg:		resource id
;;;*  .shmid:		kernel id
;;;*  .shmaddr:		address in client
;;;*  .readOnly:		how the server should attach it
;;;*
;;;*  Structure for controlling shared memory.
;;;*
struc XShmSegmentInfo
.shmseg:		resd 1	; resource id
.shmid:			resd 1	; kernel id
.shmaddr:		resd 1	; address in client
.readOnly:		resd 1	; how the server should attach it
endstruc

%endif	; _x_struc_x_h_



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: