;;;
;;; WriteChar.s
;;;
;;; created: <Tue Apr 13 20:05:13 1999>
;;; last modified: <Thu Apr 20 20:37:26 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Writes char to fd.
;;; In: WriteChar fd, char (fd [eax+0], char [eax+4])
;;; Out: eax=0(on success); eax=-1(on error)
;;;


%include "system.h"

global _WriteChar

extern _errno

%define char eax+4
%define fd eax+0

	section .text
	align 32
_WriteChar:
	push ecx
	lea ecx,[char]
	sys_write dword [fd], ecx, dword 1
	cmp eax,0
	jl .err
	pop ecx
	ret

.err:
	mov [_errno],eax
	mov eax,-1
	pop ecx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: