;;;
;;; WriteFloat.s
;;;
;;; created: <Wed Oct 20 12:30:41 1999>
;;; last modified: <Sun Apr 23 21:29:58 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Write Float (qword) *reg to fd with precision prec.
;;; In: WriteFloat fd, *reg, prec (fd [eax+0], *reg [eax+4], prec [eax+8])
;;; Out: -
;;;

%include "system.h"
%include "string.h"
%include "io.h"

global _WriteFloat
extern _IOminus,_IOpoint,_IOCharTab

%define prec esi+8
%define reg esi+4
%define fd esi+0
%define var ebp-4
%define cwbackup ebp-8
%define cw ebp-12
%define var2 ebp-20
%define mult ebp-24
%define prec2 ebp-28

	section .text
	align 32
_WriteFloat:
	push ebp
	mov ebp,esp
	sub esp,byte 28

	__push eax, ecx, esi
	mov esi,eax

;;; Save Controlword
	fstcw [cw]
	fstcw [cwbackup]

;;; If prec is 0 we need to round, if not we truncate
	or [cw],word 0000110000000000b
  	cmp [prec],dword 0
  	jne .trunc
  	and [cw],word 1111001111111111b
.trunc:
	fldcw [cw]

;;; Integer part
	mov eax,[reg]
	fld qword [eax]
	fist dword [var]
	fxam
	fstsw ax
	and ah,10b
	jz .positive
	fchs
	sys_write dword [fd], dword _IOminus, dword 1
.positive:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This handles numbers from -2147483648 to 2147483648
	fist dword [var]
	fisub dword [var]

	WriteInt dword [fd], dword [var]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Decimal part
	mov ecx,[prec]
	cmp ecx,0
	je near .end
	sys_write dword [fd], dword _IOpoint, dword 1


.loop:
	cmp [prec],dword 0
	je near .end
	cmp [prec],dword 9
	jb .doit
	sub [prec],dword 9
	mov [prec2],dword 9
	mov [mult],dword 1000000000
	jmp short .doit2
.doit:
	push ecx
	mov ecx,[prec]
	mov eax,1
.doit0:
	imul eax,10
	dec ecx
	jnz .doit0
	pop ecx
	mov [mult],eax
	mov eax,[prec]
	mov [prec2],eax
	mov [prec],dword 0
	and [cw],word 1111001111111111b	; Only round the last decimal
	fldcw [cw]
.doit2:
	fimul dword [mult]
	fist dword [var]
	call .wrtint
	fisub dword [var]
	jmp .loop

.end:
	fistp dword [var]	; Clear st0
	fldcw [cwbackup]	; Restore control word

	__pop esi, ecx, eax

	leave
	ret



.wrtint:
	__push ebx, ecx, edx
	mov ecx,[prec2]
	mov eax,[var]
	mov ebx,10
.wrtint2:
	mov edx,0
	div ebx
	push edx
	dec ecx
	jnz short .wrtint2

	mov ecx,[prec2]
.wrtint3:
	pop edx
 	add edx,dword _IOCharTab
	sys_write dword [fd], edx, dword 1
	dec ecx
	jnz short .wrtint3
	__pop edx, ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: