;;;
;;; WriteHex.s
;;;
;;; created: <02.08.1998>
;;; last modified: <Sun Apr 23 21:23:40 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Convert reg (width) to ASCII hex and write it to fd
;;; In: WriteHex fd, reg, width (8, 16, 32) (fd [eax+0], reg [eax+4], width [eax+8])
;;; Out: -
;;;

%include "system.h"

global _WriteHex
extern _IOCharTab


%define fd eax+0
%define reg eax+4
%define width eax+8

	section .text
	align 32
_WriteHex:
	__push eax, ebx, ecx, edx, esi

	mov edx,[width]
	mov esi,[reg]
	mov ebx,[fd]

	and edx,0xff
	cmp edx,32
	jnae .j0
	mov edx,32
.j0:	mov ecx,32
	sub ecx,edx
	shl esi,cl
	align 32
.j1:	shld ecx,esi,4
	shl esi,4
	and ecx,0x0f
	add ecx,dword _IOCharTab
	sys_write ebx, ecx, dword 1
	sub edx,byte 4	; !!
	jnz .j1

	__pop esi, edx, ecx, ebx, eax
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: