;;;
;;; WriteString.s
;;;
;;; created: <Sun Apr 11 18:07:59 1999>
;;; last modified: <Tue Apr  4 13:31:03 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Writes buf to fd. buf is ASCIIZ.
;;; In: WriteString fd, buf (fd [eax+0], buf [eax+4])
;;; Out: eax=0 (on success); eax=-1 (on error)
;;;
;;; buf: db "TEXT",0
;;;

%include "system.h"
%include "string.h"

global _WriteString

extern _errno

%define buf ebx+4
%define fd ebx+0

	section .text
	align 32
_WriteString:
	push ebx
	mov ebx,eax
	Strlen dword [buf]
	sys_write dword [fd], dword [buf], eax
	cmp eax,0
	jnl .exit
	mov [_errno],eax
	mov eax,-1
.exit:
	pop ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: