;;;
;;; shmat.s
;;;
;;; created: <Sun Jul  2 19:48:15 2000>
;;; last modified: <Sat Sep  9 16:26:47 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; In: shmat shmid, *shmaddr, shmflg (shmid [eax+0], *shmaddr [eax+4], shmflg [eax+8])
;;; Out: eax=address of the attached shm seg (on success); eax=-1 (on error)
;;;

%include "system.h"

global _shmat
extern _errno

%define shmid eax+0
%define shmaddr eax+4
%define shmflg eax+8

	section .text
	align 32
_shmat:
	push ebx
	push dword 0
	mov ebx,esp
	sys_ipc dword SHMAT, dword [shmid], dword [shmflg], ebx, dword [shmaddr], dword 0
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov [ebx],dword -1	; set eax
.noerr:
	pop eax
	pop ebx
	ret

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: