;;;
;;; shmctl.s
;;;
;;; created: <Sun Jul  2 19:42:59 2000>
;;; last modified: <Sun Jul  2 22:48:54 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; In: shmctl shmid, cmd, *buf (shmid [eax+0], cmd [eax+4], *buf [eax+8])
;;; Out: eax=shmid (on success); eax=-1 (on error)
;;;

%include "system.h"

global _shmctl
extern _errno

%define shmid eax+0
%define cmd eax+4
%define buf eax+8

	section .text
	align 32
_shmctl:
	sys_ipc dword SHMCTL, dword [shmid], dword [cmd], dword 0, dword [buf],  dword 0
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: