;;;
;;; shmget.s
;;;
;;; created: <Sun Jul  2 17:56:22 2000>
;;; last modified: <Sun Jul  2 18:55:45 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; In: shmget key, size, shmflg (key [eax+0], size [eax+4], shmflg [eax+8])
;;; Out: eax=shmid (on success); eax=-1 (on error)
;;;

%include "system.h"

global _shmget
extern _errno

%define key eax+0
%define size eax+4
%define shmflg eax+8

	section .text
	align 32
_shmget:
	sys_ipc dword SHMGET, dword [key], dword [size], dword [shmflg], dword 0, dword 0
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: