;;;
;;; RandomString.s
;;;
;;; created: <Sun May 23 17:22:07 1999>
;;; last modified: <Thu Jun  1 17:07:38 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Read n bytes of random from /dev/random in *buf. Make sure, that this
;;; device is initialised for 'real' randomness...
;;;  In: RandomString *buf, n (*buf [eax+0], n [eax+4])
;;;  Out: eax=*buf
;;;

%include "system.h"
%include "io.h"
%include "string.h"

global _RandomString
extern _errno,_argv

%define buf ebx+0
%define n ebx+4

	section .text
	align 32
_RandomString:
	push ebx
	mov ebx,eax

	sys_open dword dev, dword O_RDONLY, dword 0
	cmp eax,-1
	jle .err
	push eax
	sys_read eax, dword [buf], dword [n]
	cmp eax,-1
	jle .err
	pop eax
	sys_close eax
	cmp eax,-1
	jle .err
	mov eax,[buf]

	pop ebx
	ret

.err:
	;; Write prg name, and msg
	mov [_errno],eax
	GetErrorStr dword [_errno]
	mov ebx,dword [_argv]
	WritefSTDERR '%e: _RandomString: Could not read from %e. (%e)',lf, dword [ebx], dword dev, eax
	;; See ya!
	sys_exit dword 1

	align 32
dev:	db "/dev/random",0



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: