;;;
;;; StartupCode.s
;;;
;;; created: <02.08.1998>
;;; last modified: <Thu 24 Oct 2002 11:17:26 PM CEST>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;; Taken from glibc-2.1/sysdeps/i386/elf/start.S
;;;  This is the canonical entry point, usually the first thing in the text
;;;  segment.  The SVR4/i386 ABI (pages 3-31, 3-32) says that when the entry
;;;  point runs, most registers' values are unspecified, except for:
;;;
;;;  %edx		Contains a function pointer to be registered with `atexit'.
;;;   		This is how the dynamic linker arranges to have DT_FINI
;;;		functions called for shared libraries that have been loaded
;;;		before this code runs.
;;;
;;;  %esp		The stack contains the arguments and environment:
;;;   		0(%esp)			argc
;;;		4(%esp)			argv[0]
;;;		...
;;;		(4*argc)(%esp)		NULL
;;;		(4*(argc+1))(%esp)	envp[0]
;;;		...
;;;					NULL
;;;

;;;
;;; This sets up some variables for the program. Should be called first.
;;; Use the `StartupCode' macro.
;;;

%include "system.h"
%include "linux/structs.h"

global _StartupCode
global _argc,_argv,_envp,_errno,_kver
extern main


%define counter ebp-4
%define uts ebp-4-new_utsname_size

	section .text
	align 32
_StartupCode:
	push ebp
	mov ebp,esp
	sub esp,new_utsname_size+4

	__push eax, ebx, ecx, edi

;;; Get kernel version (-> [_kver]=0x0002020e for 2.2.14)
;;; If [_kver]=0, sys_uname failed.
	mov [_kver],dword 0
	lea ebx,[uts]
	sys_uname ebx
	cmp eax,-1
	je .doesnotmatter	; Pfffft. Error.

	mov [counter],dword 3
	lea ebx,[uts+new_utsname.release]
	mov edi,0
.loop:
	movzx eax,byte [ebx]
	mov ecx,allowed_chars_size+1
	cld
	push edi
	mov edi,allowed_chars
	repne scasb
	pop edi
	jecxz .loop_j3
	cmp al,'.'
	je .loop_j2
	inc ebx
	sub eax,byte 48
	imul edi,10
	add edi,eax
	jmp short .loop
.loop_j2:
	dec dword [counter]
	jz .doesnotmatter
	shl dword [_kver],8
	or [_kver],edi
	mov edi,0
	inc ebx
	jmp short .loop
.loop_j3:
	shl dword [_kver],8
	or [_kver],edi

.doesnotmatter:
;;; Commandline
	mov ebx,[ebp+8]
	mov [_argc],ebx
	lea edi,[ebp+12]	; edi=ebp+12
	mov [_argv],edi

;;; Environment
	lea edi,[edi+(ebx+1)*4]	; edi=edi+(ebx+1)*4
	mov [_envp],edi

	__pop edi, ecx, ebx, eax

	leave
	ret

allowed_chars:	db ".0123456789"
allowed_chars_size equ $-allowed_chars

	section .bss
	alignb 32
_argc:		resd 1		; number of arguments
_argv:		resd 1		; pointer to arguments
_envp:		resd 1		; pointer to environment varibles
_errno:		resd 1		; contains errorcodes as they come from system calls (<0)
_kver:		resd 1		; kernel version (see above)



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: