;;;
;;; SEQ_sendevent.s
;;;
;;; created: <Tue Sep 14 00:16:43 1999>
;;; last modified: <Tue Apr  4 21:37:38 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; This sends an event to snd.seqbuf
;;;

global _SEQ_sendevent
extern _seqbuf,_seqbufptr,_seqbufsize

%include "system.h"
%include "io.h"
%include "seq.h"

%define event_size ebp+8
%define event ebp+4
%define _snd ebp+0

	section .text
	align 32
_SEQ_sendevent:
	__push ebx, ecx, esi, edi, ebp
	mov ebp,eax
	mov ebx,[_snd]

	;; Test snd.seqbuf overflow
	mov ecx,[event_size]
	jecxz .exit
	add ecx,[ebx+snd.seqbufptr]
	cmp ecx,SEQ_buf_size
	jb .letsgo
	SEQ_bufdump dword [_snd]
.letsgo:

	;; Place for current event
	mov ecx,[event_size]
	lea edi,[ebx+snd.seqbuf]
	add edi,[ebx+snd.seqbufptr]
	add [ebx+snd.seqbufptr],ecx

	;; Copy event to snd.seqbuf
	mov esi,[event]
	rep movsb

.exit:
	__pop ebp, edi, esi, ecx, ebx
	ret



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: