;;;
;;; XAllocID.s
;;;
;;; created: <Mon Nov 29 14:19:31 1999>
;;; last modified: <Sat Jun 17 14:47:40 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; XAllocID: resource ID allocation routine
;;;
;;; In: XAllocID *dpy (eax)
;;; Out: eax=resource ID
;;;

;;; FIXME:XAllocID.s: May need to implement XC-Misc Extension...

%include "system.h"
%include "io.h"
%include "x_func.h"
%include "x_struc_l.h"

global _XAllocID
extern _errno,_argv

	section .text
	align 32
_XAllocID:
	__push ebx, ecx
	mov ebx,eax
	mov eax,[ebx+dpystruc.resource_id]
	mov ecx,[ebx+dpystruc.resource_shift]
	shl eax,cl
	cmp eax,[ebx+dpystruc.resource_max]
	jb .j1
	mov ecx,[ebx+dpystruc.resource_mask]
	inc ecx
	mov [ebx+dpystruc.resource_max],ecx
.j1:
	cmp eax,[ebx+dpystruc.resource_mask]
	ja .j2
	inc dword [ebx+dpystruc.resource_id]
	add eax,[ebx+dpystruc.resource_base]
	__pop ecx, ebx
	ret
.j2:
	cmp eax,0x10000000
	je .j3
	mov eax,dword [_argv]
	WritefSTDERR '%e: _XAllocID: resource ID allocation space exhaused!',lf, dword [eax]
	mov eax,0x10000000
	push eax
	mov ecx,[ebx+dpystruc.resource_shift]
	shr eax,cl
	mov [ebx+dpystruc.resource_id],eax
	pop eax
.j3:
	__pop ecx, ebx
	ret

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: