;;;
;;; XCMiscGetXIDRange.s
;;;
;;; created: <Sat Jun 17 11:26:25 2000>
;;; last modified: <Wed Jun 28 12:11:40 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "x_struc_l.h"
%include "mem.h"
%include "string.h"
%include "sys.h"

global _XCMiscGetXIDList

extern _errno

%define dpy ebx+0
%define count ebx+4
%define ids ebx+8
%define nids ebx+12

%define request ecx
%define reply ecx

	section .text
	align 32
_XCMiscGetXIDList:
	__push ebx, ecx, edx
	mov ebx,eax

;;; XC-Misc Extension availible?
	mov eax,[dpy]
	cmp [eax+dpystruc.XC_MISC_opcode],dword 0
	je near .notavail		; No :(

	MemoryAllocate dword 2*4
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: XCMiscGetXIDList
	mov eax,[dpy]
	mov eax,[eax+dpystruc.XC_MISC_opcode]
	mov [request+0],al
	mov [request+1],byte X_XCMiscGetXIDList
;;; request length
	mov [request+2],word 2
;;; count
	mov eax,[count]
	mov [request+4],eax

	XSync dword [dpy], request, dword 2*4
	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .wait
	mov eax,-1
	jmp near .end
;;; Wait for that reply:
.wait:
	cmp eax,-1
	je near .end
	cmp eax,0
	jne .ok
	Sleep dword 0, dword 50	; :)
	XSync dword [dpy], dword 0, dword 0

	jmp short .wait		; Wait for reply!!!!
.ok:
	mov reply,eax

	mov edx,[nids]
	mov eax,[reply+8]
	cmp edx,0
	je .p1
	mov [edx],eax
.p1:
	mov edx,eax
	shr edx,2
	lea eax,[reply+32]
	Strncpy eax, dword [ids], edx

	MemoryFree reply
	cmp eax,-1
	je .end
	mov eax,0

.end:
	__pop edx, ecx, ebx
	ret

.notavail:
	mov [_errno],dword -ENOPROTOOPT
	mov eax,-1
	jmp short .end


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: