;;;
;;; XCMiscGetXIDRange.s
;;;
;;; created: <Sat Jun 17 10:38:03 2000>
;;; last modified: <Wed Jun 28 12:11:45 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "x_struc_l.h"
%include "mem.h"
%include "string.h"
%include "sys.h"

global _XCMiscGetXIDRange

extern _errno

%define dpy ebx+0
%define start_id ebx+4
%define count ebx+8

%define request ecx
%define reply ecx

	section .text
	align 32
_XCMiscGetXIDRange:
	__push ebx, ecx, edx
	mov ebx,eax

;;; XC-Misc Extension availible?
	mov eax,[dpy]
	cmp [eax+dpystruc.XC_MISC_opcode],dword 0
	je near .notavail		; No :(

	MemoryAllocate dword 1*4
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: XCMiscGetXIDRange
	mov eax,[dpy]
	mov eax,[eax+dpystruc.XC_MISC_opcode]
	mov [request+0],al
	mov [request+1],byte X_XCMiscGetXIDRange
;;; request length
	mov [request+2],word 1

	XSync dword [dpy], request, dword 1*4
	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .wait
	mov eax,-1
	jmp near .end
;;; Wait for that reply:
.wait:
	cmp eax,-1
	je near .end
	cmp eax,0
	jne .ok
	Sleep dword 0, dword 50	; :)
	XSync dword [dpy], dword 0, dword 0

	jmp short .wait		; Wait for reply!!!!
.ok:
	mov reply,eax

	mov edx,[start_id]
	cmp edx,0
	je .p1
	movzx eax,byte [reply+9]
	mov [edx],eax
.p1:
	mov edx,[count]
	cmp edx,0
	je .p2
	movzx eax,byte [reply+10]
	mov [edx],eax
.p2:

	MemoryFree reply
	cmp eax,-1
	je .end
	mov eax,0

.end:
	__pop edx, ecx, ebx
	ret

.notavail:
	mov [_errno],dword -ENOPROTOOPT
	mov eax,-1
	jmp short .end

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: