;;;
;;; XChangeGC.s
;;;
;;; created: <Sat May 27 20:00:48 2000>
;;; last modified: <Sun Sep 10 12:50:55 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "x_struc_x.h"
%include "mem.h"

global _XChangeGC

%define dpy ebx+0
%define gc ebx+4
%define valuemask ebx+8
%define values ebx+12

%define request ecx

%macro vl 2
	mov eax,[request+8]
	and eax,%1
	jz %%end
	mov eax,%2
	mov [ebp],eax
	add ebp,byte 4
	inc word [request+2]
%%end:
%endm

	section .text
	align 32
_XChangeGC:
	__push ebx, ecx, edx, ebp
	mov ebx,eax
	MemoryAllocate dword 4*26
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: ChangeGC
	mov [request+0],byte X_ChangeGC
;;; request length (later modified)
	mov [request+2],word 3
;;; gc
	mov eax,[gc]
	mov [request+4],eax
;;; valuemask
	mov eax,[valuemask]
	and eax,(1<<(GCLastBit+1))-1
	mov [request+8],eax
;;; values
	mov edx,[values]
	lea ebp,[request+12]

	vl GCFunction, [edx+XGCValues.function]
	vl GCPlaneMask, [edx+XGCValues.plane_mask]
	vl GCForeground, [edx+XGCValues.foreground]
	vl GCBackground, [edx+XGCValues.background]
	vl GCLineWidth, [edx+XGCValues.line_width]
	vl GCLineStyle, [edx+XGCValues.line_style]
	vl GCCapStyle, [edx+XGCValues.cap_style]
	vl GCJoinStyle, [edx+XGCValues.join_style]
	vl GCFillStyle, [edx+XGCValues.fill_style]
	vl GCFillRule, [edx+XGCValues.fill_rule]
	vl GCTile, [edx+XGCValues.tile]
	vl GCStipple, [edx+XGCValues.stipple]
	vl GCTileStipXOrigin, [edx+XGCValues.ts_x_origin]
	vl GCTileStipYOrigin, [edx+XGCValues.ts_y_origin]
	vl GCFont, [edx+XGCValues.font]
	vl GCSubwindowMode, [edx+XGCValues.subwindow_mode]
	vl GCGraphicsExposures, [edx+XGCValues.graphics_exposures]
	vl GCClipXOrigin, [edx+XGCValues.clip_x_origin]
	vl GCClipYOrigin, [edx+XGCValues.clip_y_origin]
	vl GCClipMask, [edx+XGCValues.clip_mask]
	vl GCDashOffset, [edx+XGCValues.dash_offset]
	vl GCDashList, [edx+XGCValues.dashes]
	vl GCArcMode, [edx+XGCValues.arc_mode]

	movzx ebp,word [request+2]
	shl ebp,2
	XSync dword [dpy], request, ebp

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne near .end
	mov eax,-1
.end:
	__pop ebp, edx, ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: