;;;
;;; XChangeProperty.s
;;;
;;; created: <Mon Mar 13 17:11:19 2000>
;;; last modified: <Tue May  9 17:23:23 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "mem.h"
%include "string.h"
%include "x_func.h"
%include "x_def.h"

global _XChangeProperty

%define dpy ecx+0
%define wid ecx+4
%define property ecx+8
%define type ecx+12
%define format ecx+16
%define mode ecx+20
%define data ecx+24
%define nelements ecx+28

%define request ebx

	section .text
	align 32
_XChangeProperty:
	__push ebx, ecx, edx
	mov ecx,eax

	cmp [nelements],dword 0
	jnl .ok
	mov [nelements],dword 0
	mov [format],dword 0
.ok:
;;; allocate memory for request
	mov eax,[nelements]
	add eax,byte 3
	shr eax,2
	add eax,byte 6
	mov edx,eax
	shl edx,2
	MemoryAllocate eax
	cmp eax,-1
	je near .end
	mov request,eax

;;; opcode: ChangeProperty
	mov [request+0],byte X_ChangeProperty
;;; mode
	mov eax,[mode]
	mov [request+1],al
;;; request length
	mov eax,edx
	shr eax,2
	mov [request+2],ax
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; property
	mov eax,[property]
	mov [request+8],eax
;;; type
	mov eax,[type]
	mov [request+12],eax
;;; format
	mov [request+16],dword 0
	mov eax,[format]
	mov [request+16],al
;;; length
	mov eax,[nelements]
	cmp [format],dword 8
	jne short .isnot8
	mov [request+20],eax
	jmp short .isnot32
.isnot8:
	cmp [format],dword 16
	jne short .isnot16
	shr eax,1
	mov [request+20],eax
	jmp short .isnot32
.isnot16:
	cmp [format],dword 32
	jne short .isnot32
	shr eax,2
	mov [request+20],eax
.isnot32:
;;; data
	lea eax,[request+24]
	Strncpy dword [data], eax, dword [nelements]

	XSync dword [dpy], request, edx
.end0:
	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop edx, ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: