;;;
;;; XChangeWindowAttributes.s
;;;
;;; created: <Fri May 26 17:54:17 2000>
;;; last modified: <Sun Sep 10 12:52:06 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x.h"
%include "mem.h"

global _XChangeWindowAttributes

%define dpy edx+0
%define wid edx+4
%define valuemask edx+8
%define attributes edx+12

%define request ebp

%macro vl 2
	mov eax,[request+8]
	and eax,%1
	jz %%end
	mov eax,%2
	mov [ebx],eax
	add ebx,byte 4
	inc word [request+2]
%%end:
%endm

	section .text
	align 32
_XChangeWindowAttributes:
	__push ebx, ecx, edx, ebp
	mov edx,eax

;;; Get memory for request
	MemoryAllocate dword 12+32*4
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: ChangeWindowAttributes
	mov [request+0],byte X_ChangeWindowAttributes
;;; request length (later modified)
	mov [request+2],word 3
;;; wid
	mov eax,[wid]
	mov [request+4],eax
;;; valuemask
	mov eax,[valuemask]
	and eax,AllMaskBits
	mov [request+8],eax

;;; Value-list
	lea ebx,[request+12]
	mov ecx,[attributes]

	vl CWBackPixmap, [ecx+XSetWindowAttributes.background_pixmap]
	vl CWBackPixel, [ecx+XSetWindowAttributes.background_pixel]
	vl CWBorderPixmap, [ecx+XSetWindowAttributes.border_pixmap]
	vl CWBorderPixel, [ecx+XSetWindowAttributes.border_pixel]
	vl CWBitGravity, [ecx+XSetWindowAttributes.bit_gravity]
	vl CWWinGravity, [ecx+XSetWindowAttributes.win_gravity]
	vl CWBackingStore, [ecx+XSetWindowAttributes.backing_store]
	vl CWBackingPlanes, [ecx+XSetWindowAttributes.backing_planes]
	vl CWBackingPixel, [ecx+XSetWindowAttributes.backing_pixel]
	vl CWOverrideRedirect, [ecx+XSetWindowAttributes.override_redirect]
	vl CWSaveUnder, [ecx+XSetWindowAttributes.save_under]
	vl CWEventMask, [ecx+XSetWindowAttributes.event_mask]
	vl CWDontPropagate, [ecx+XSetWindowAttributes.do_not_propagate_mask]
	vl CWColormap, [ecx+XSetWindowAttributes.colormap]
	vl CWCursor, [ecx+XSetWindowAttributes.cursor]

	movzx ecx,word [request+2]
	shl ecx,2
	XSync dword [dpy], request, ecx

;;; Free memory block
	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop ebp, edx, ecx, ebx
	ret

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: