;;;
;;; XCopyGC.s
;;;
;;; created: <Sat May 27 20:00:48 2000>
;;; last modified: <Fri Jun  9 22:44:39 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"

global _XCopyGC

%define dpy ebx+0
%define src_gc ebx+4
%define valuemask ebx+8
%define dst_gc ebx+12

%define request ecx

	section .text
	align 32
_XCopyGC:
	__push ebx, ecx
	mov ebx,eax
	MemoryAllocate dword 4*4
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: CopyGC
	mov [request+0],byte X_CopyGC
;;; request length
	mov [request+2],word 4
;;; src_gc
	mov eax,[src_gc]
	mov [request+4],eax
;;; dst_gc
	mov eax,[dst_gc]
	mov [request+8],eax
;;; valuemask
	mov eax,[valuemask]
	and eax,(1<<(GCLastBit+1))-1
	mov [request+12],eax

	XSync dword [dpy], request, dword 4*4

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne near .end
	mov eax,-1
.end:
	__pop ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: