;;;
;;; XFindVisualTypeDSAddr.s
;;;
;;; created: <Tue Mar  7 16:59:07 2000>
;;; last modified: <Sat Sep  9 20:44:09 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_struc_x.h"
%include "x_func.h"

global _XFindVisualTypeDSAddr

%define dpy ebx+0
%define vid ebx+4
%define depth ebx+8
%define screen ebx+12

	section .text
	align 32
_XFindVisualTypeDSAddr:
	__push ebx, ecx, edx
	mov ebx,eax

;;; First: Get adress of Depth
	XDepthAddr dword [dpy], dword [depth], dword [screen]
	cmp eax,-1
	je .end

;;; Second: Get adress of VisualType
	mov edx,eax
	add edx,xDepth_size
	movzx ecx,word [eax+xDepth.nVisuals]
	mov eax,[vid]
.loop:
	cmp [edx+xVisualType.visualID],eax
	je .gotit
	add edx,xVisualType_size
	dec ecx
	jnz .loop
	jmp short .error

.gotit:
	mov eax,edx

.end:
	__pop edx, ecx, ebx
	ret

.error:
	mov eax,-1
	jmp short .end


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: