;;;
;;; XFindVisualTypeSAddr.s
;;;
;;; created: <Tue Mar  7 18:06:39 2000>
;;; last modified: <Sat Sep  9 19:59:33 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_struc_x.h"
%include "x_func.h"

global _XFindVisualTypeSAddr

%define dpy ebx+0
%define vid ebx+4
%define screen ebx+8

	section .text
	align 32
_XFindVisualTypeSAddr:
	__push ebx, ecx, edx, esi
	mov ebx,eax

	XScreenAddr dword [dpy], dword [screen]
	cmp eax,-1
	je .end
	mov edx,eax

	movzx eax,byte [edx+xWindowRoot.nDepths]
	mov esi,eax
	cmp eax,0
	je .error
	add edx,xWindowRoot_size
	mov eax,[vid]

.loop:
	movzx ecx,word [edx+xDepth.nVisuals]
	add edx,xDepth_size
.loop2:
	cmp [edx+xVisualType.visualID],eax
	je .gotit
	add edx,xVisualType_size
	dec ecx
	jnz .loop2
	dec esi
	jnz .loop
	jmp short .error

.gotit:
	mov eax,edx

.end:
	__pop esi, edx, ecx, ebx
	ret

.error:
	mov eax,-1
	jmp short .end



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: