;;;
;;; XQueryExtension.s
;;;
;;; created: <Sat Jun 17 09:36:47 2000>
;;; last modified: <Sat Jun 17 10:34:58 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "mem.h"
%include "string.h"
%include "sys.h"

global _XQueryExtension

%define dpy ebx+0
%define name ebx+4
%define mopcode ebx+8
%define firstevent ebx+12
%define firsterror ebx+16

%define request ecx
%define reply ecx

	section .text
	align 32
_XQueryExtension:
	__push ebx, ecx, edx, esi
	mov ebx,eax
	Strlen dword [name]
	mov edx,eax
	shr eax,2
	inc eax
	shl eax,2
	add eax,byte 8
	mov esi,eax
	MemoryAllocate eax
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: QueryExtension
	mov [request+0],byte X_QueryExtension
;;; request length (later modified)
	mov eax,esi
	shr eax,2
	mov [request+2],ax
;;; name length
	mov [request+4],dx
;;; name
	lea eax,[request+8]
	Strncpy dword [name], eax, edx

	XSync dword [dpy], request, esi
	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .wait
	mov eax,-1
	jmp near .end
;;; Wait for that reply:
.wait:
	cmp eax,-1
	je near .end
	cmp eax,0
	jne .ok
	Sleep dword 0, dword 50	; :)
	XSync dword [dpy], dword 0, dword 0

	jmp short .wait		; Wait for reply!!!!
.ok:
	mov reply,eax

;;; present?
	cmp [reply+8],byte xTrue
	je .present
	MemoryFree reply
	mov eax,-1
	jmp short .end
;;; Yes!
.present:
	mov edx,[mopcode]
	cmp edx,0
	je .p1
	movzx eax,byte [reply+9]
	mov [edx],eax
.p1:
	mov edx,[firstevent]
	cmp edx,0
	je .p2
	movzx eax,byte [reply+10]
	mov [edx],eax
.p2:
	mov edx,[firsterror]
	cmp edx,0
	je .p3
	movzx eax,byte [reply+11]
	mov [edx],eax
.p3:

	MemoryFree reply
	cmp eax,-1
	je .end
	mov eax,0

.end:
	__pop esi, edx, ecx, ebx
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: