;;;
;;; XScreenAddr.s
;;;
;;; created: <Tue Dec 28 16:18:31 1999>
;;; last modified: <Mon Apr 17 19:30:42 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_struc.h"

global _XScreenAddr

%define dpy eax+0
%define screen eax+4

	section .text
	align 32
_XScreenAddr:
	__push ebx, ecx, edx, esi, edi

;;; Check if screen is valid
	mov edi,[screen]
	mov ebx,[dpy]
	mov eax,[ebx+dpystruc.nscreens]
	dec eax
	cmp eax,edi
	ja .error

	mov esi,0
	mov edx,[ebx+dpystruc.pscreens]
.loop:
	cmp esi,edi
	jne .loop_j1
;;; Got address
	mov eax,edx
	jmp .end

;;; Jump to next screen
.loop_j1:
	movzx ecx,byte [edx+xWindowRoot.nDepths]
	add edx,xWindowRoot_size

	jecxz .loop_j3
.loop_j2:
	movzx eax,word [edx+xDepth.nVisuals]
	imul eax,xVisualType_size
	add eax,xDepth_size
	add edx,eax
	loop .loop_j2
.loop_j3:
	inc esi
	jmp .loop

.end:
	__pop edi, esi, edx, ecx, ebx
	ret

.error:
	mov eax,-1
	jmp short .end


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: