;;;
;;; XShmPutImage.s
;;;
;;; created: <Sat Sep  9 13:57:55 2000>
;;; last modified: <Sat Sep  9 20:54:33 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_func.h"
%include "x_def.h"
%include "x_struc.h"
%include "mem.h"

global _XShmPutImage

extern _errno

%define dpy ebx+0
%define wid ebx+4
%define gc ebx+8
%define image ebx+12
%define src_x ebx+16
%define src_y ebx+20
%define dst_x ebx+24
%define dst_y ebx+28
%define src_width ebx+32
%define src_height ebx+36
%define send_event ebx+40

%define request ecx

	section .text
	align 32
_XShmPutImage:
	__push ebx, ecx, edx
	mov ebx,eax

;;; MIT-SHM Extension availible?
	mov eax,[dpy]
	cmp [eax+dpystruc.MIT_SHM_opcode],dword 0
	je near .notavail		; No :(
	
	MemoryAllocate dword 4*10
	cmp eax,-1
	je near .end
	mov request,eax

;;; Opcode: ShmPutImage
	mov eax,[dpy]
	mov eax,[eax+dpystruc.MIT_SHM_opcode]
	mov [request+0],al
	mov [request+1],byte X_ShmPutImage
;;; request length
	mov [request+2],word 10
;;; drawable
	mov eax,[wid]
	mov [request+4],eax
;;; gc
	mov eax,[gc]
	mov [request+8],eax
;;; total width
	mov edx,[image]
	mov eax,[edx+ximagestruc.width]
	mov [request+12],ax
;;; total height
	mov eax,[edx+ximagestruc.height]
	mov [request+14],ax
;;; src x
	mov eax,[src_x]
	mov [request+16],ax
;;; src y
	mov eax,[src_y]
	mov [request+18],ax
;;; src height
	mov eax,[src_height]
	mov [request+20],ax
;;; src width
	mov eax,[src_width]
	mov [request+22],ax
;;; dst x
	mov eax,[dst_x]
	mov [request+24],ax
;;; dst y
	mov eax,[dst_y]
	mov [request+26],ax
;;; depth
	mov eax,[edx+ximagestruc.depth]
	mov [request+28],al
;;; format
	mov eax,[edx+ximagestruc.format]
	mov [request+29],al
;;; send event
	mov eax,[send_event]
	mov [request+30],al
;;; bpad
	mov [request+31],byte 0

;;; offset
	mov eax,[edx+ximagestruc.data]
	mov edx,[edx+ximagestruc.obdata]
	sub eax,[edx+XShmSegmentInfo.shmaddr]
	mov [request+36],eax
;;; ShmSeg
	mov eax,[edx+XShmSegmentInfo.shmseg]
	mov [request+32],eax

	XSync dword [dpy], request, dword 4*10 ; 4*(request length)

	push eax
	MemoryFree request
	cmp eax,-1
	pop eax
	jne .end
	mov eax,-1
.end:
	__pop edx, ecx, ebx
	ret

.notavail:
	mov [_errno],dword -ENOPROTOOPT
	mov eax,-1
	jmp short .end


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: