;;;
;;; XVisualTypeIDAddr.s
;;;
;;; created: <Sat Sep  9 20:04:08 2000>
;;; last modified: <Sat Sep  9 20:35:37 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

%include "system.h"
%include "x_struc_x.h"
%include "x_func.h"

global _XVisualTypeIDAddr

%define dpy ebx+0
%define vid ebx+4

	section .text
	align 32
_XVisualTypeIDAddr:
	__push ebx, ecx, edx, esi, edi
	mov ebx,eax

;;; Scan all screens (edi=0; edi=edi+1) until we find vid
	mov edi,0
.loop:
	XScreenAddr dword [dpy], edi ; will report error, if screen is not present
	cmp eax,-1
	je .end

	mov esi,eax
	add esi,xWindowRoot_size

;;; Step through all Depths
	movzx ecx,byte [esi-xWindowRoot_size+xWindowRoot.nDepths]
.loop2:
	add esi,xDepth_size
	mov eax,[vid]

;;; Step through all VisualTypes
	movzx edx,byte [esi-xDepth_size+xDepth.nVisuals]
.loop3:
	cmp [esi+xVisualType.visualID],eax
	je .gotit
	add esi,xVisualType_size
	dec edx
	jnz .loop3

	dec ecx
	jnz .loop2

	inc edi
	jmp .loop

.gotit:
	mov eax,esi

.end:
	__pop edi, esi, edx, ecx, ebx
	ret

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: