﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace binviz.searcher
{
	class DefaultSearch : AbstractSearch
	{
        private static const string XS_NAME = "Default Search";

        /// <summary>
        /// Returns the name of this search type
        /// </summary>
        /// <returns>string</returns>
        String getName()
        {
            return XS_NAME;
        }

        /// <summary>
        /// Finds the given byte array in the provided byte array and returns zero or more search result objects
        /// in the form if an IList collection. This method will never return null.
        /// </summary>
        /// <param name="vab_bytes_to_find">byte array to find</param>
        /// <param name="vab_to_search">byte array to search</param>
        /// <returns>an IList of zero or more search results. If the array to be searched is smaller than the number
        /// of bytes provided to look for, an empty IList is returned. If either array is null, an exception is
        /// thrown. If the bytes to find is of length of 0, an empty List is returned.</returns>
        /// <exception cref="ArgumentException">thrown if either parameter is null</exception>
        IList<SearchResult> getResults(byte[] vab_bytes_to_find, byte[] vab_to_search)
        {
            if (vab_bytes_to_find == null)
                throw new ArgumentException("Bytes to find is null");
            if (vab_to_search == null)
                throw new ArgumentException("Bytes to search are null");

            IList<SearchResult> o_results = new LinkedList<SearchResult>();
            if (vab_bytes_to_find.Length > 0 || vab_bytes_to_find.Length <= vab_to_search)
            {
            }
            return o_results;
        }
	}
}
