﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VizBin.searcher
{
	class DefaultSearch : AbstractSearch
	{
        private const string XS_NAME = "Default Search";

        /// <summary>
        /// Returns the name of this search type
        /// </summary>
        /// <returns>string</returns>
        public override String getName()
        {
            return XS_NAME;
        }

		/// <summary>
		/// Return true if the byte array elements are exactly the same using the == method.
		/// </summary>
		/// <param name="vab_ref_bytes">the bytes we're looking for</param>
		/// <param name="vab_search_bytes">the bytes to check</param>
		/// <returns>true if they match, false otherwise</returns>
		private bool isEqual(byte[] vab_ref_bytes, byte[] vab_search_bytes)
		{
			bool b_eq = vab_ref_bytes.Length == vab_search_bytes.Length;
			if (b_eq)
			{
				for (int i = 0; i < vab_ref_bytes.Length && b_eq == true; i++)
					b_eq = vab_ref_bytes[i] == vab_search_bytes[i];
			}
			return b_eq;
		}
	}
}
